{--------------------------------------------------------------}
{                                                              }
{  DsIMemPool.inc - IMemPool interface declaration             }
{                                                              }
{  Author:     Semi                                            }
{  Started:    171113 , previous DsmAlloc1.inc 171107          }
{                                                              }
{                                                              }
{--------------------------------------------------------------}

{$ifdef UNIT}
{$undef UNIT}
unit DsIMemPool;
interface uses Windows; {$define DSIMEMPOOL_END}
{$endif UNIT}

//-------------------------------------------------------------
{$ifndef DSIMEMPOOL_HDR}
{$define DSIMEMPOOL_HDR}


// IMemPool
{$ifndef IMEMPOOL} {$define IMEMPOOL}
type
  IMemPool=interface(IUnknown) {$define IMEMPOOL}
    ['{C86E6EBE-5962-2A2F-750E-506FFC551538}']
    function Alloc(Size: integer): Pointer;
    function Free(Item: Pointer): Boolean;
    function ReAlloc(var Item: Pointer; NewSize: integer): Boolean;
    function Query(Item: Pointer): integer;
  end;
  PIMemPool=^IMemPool;
  
  {$ifndef IUNKNOWNVMT} {$define IUNKNOWNVMT} //"ifndef"New191108
  PIUnknownVmt=^TIUnknownVmt;
  TIUnknownVmt=record
    QueryInterface: function(Unk: Pointer; const IID: TGUID; out Obj): HResult; stdcall;
    AddRef: function(Unk: Pointer): Integer; stdcall;
    Release: function(Unk: Pointer): Integer; stdcall;
  end;
  {$endif IUNKNOWNVMT}
  
  PIMemPoolVmt=^TIMemPoolVmt;
  TIMemPoolVmt=record
    Unk:           TIUnknownVmt;
    Alloc:         function(PoolUnk: Pointer; Size: integer): Pointer;
    Free:          function(PoolUnk: Pointer; Item: Pointer): Boolean;
    ReAlloc:       function(PoolUnk: Pointer; var Item: Pointer; NewSize: integer): Boolean;
    Query:         function(PoolUnk: Pointer; Item: Pointer): integer;
  end;

const
  {$ifndef guid_IUnknown} {$define guid_IUnknown}
  guid_IUnknown:TGuid='{00000000-0000-0000-C000-000000000046}';
  {$endif}
  guid_IMemPool:TGuid='{C86E6EBE-5962-2A2F-750E-506FFC551538}';
  guid_IMalloc: TGuid='{00000002-0000-0000-C000-000000000046}'; //New200825
{$endif !IMEMPOOL}




{$endif !DSIMEMPOOL_HDR}
{$ifndef INTERFACE}{$ifndef DSIMEMPOOL_INC}{$define DSIMEMPOOL_INC}
//-------------------------------------------------------------
{$ifdef DSIMEMPOOL_END}
implementation
{$endif DSIMEMPOOL_END}



{$ifdef DSIMEMPOOL_END} {$warnings off}end.{$endif DSIMEMPOOL_END}
{$endif DSIMEMPOOL_INC}{$endif IMPLEMENTATION}
